Subject: Re: bug#42002: Bug: Signal kill during build

From: Efraim Flashner <[email-masked]>
Date: Tue, 23 Jun 2020 08:57:52 +0300

On Tue, Jun 23, 2020 at 03:38:39AM +0300, Bonface M. K. wrote:
> Léon Lain Delysid <[email-masked]> writes:
> 
> > Oh! Yes, of course, I see!
> > Yes, those little credit card sized one-chip computers are very low on resources.
> > So I think it shouldn't build the programs itself but rather download the binaries everytime I "guix pull". What command line
> > option should I use to only download the binaries instead of building everything myself? Could you please give me the command?
> >
> You could try: `guix pull --substitute-urls="https://berlin.guixsd.org
> https://ci.guix.gnu.org https://mirror.hydra.gnu.org"`. Since you are on
> Debian, you should authorize the servers. More of the authorization
> here:
> https://guix.gnu.org/manual/en/html_node/Substitute-Server-Authorization.html.
> You could always dry-run your commands to see if the substitutes work.

Actually, berlin.guixsd.org and ci.guix.gnu.org are the same server, and
mirror.hydra.gnu.org was decommissioned a while ago. The second server
for substitutes is https://bayfront.guix.gnu.org.

I think the best option would be to make sure you run 'guix pull'
targeting a derivation which has substitutes. If you check here¹ you can
see if there's a substitute already available for armhf-linux and run
'guix pull --commit=the-commit-listed-in-the-link'. Right now, that
would be 42a2ee1f9294614bd85892f2cc7318afb80b174c, which is actually the
latest commit.

¹ https://ci.guix.gnu.org/jobset/guix-modular-master

> 
> > On Mon, Jun 22, 2020, 14:47 Efraim Flashner <[email-masked]> wrote:
> >
> >     On Mon, Jun 22, 2020 at 02:28:33PM +0200, Léon Lain Delysid wrote:
> >     > Hello! I'm having a problem on a Banana Pi M3 that runs Debian 10 Buster
> >     > (ARM like instruction set).
> >     > "guix pull" always results in failure with this message:
> >     >
> >     > building
> >     > /gnu/store/3has7cgd39q9jb9a78vdzjcyycsa6z96-guix-packages-base.drv...
> >     >  76% [#######################################################
> >     >    ]builder for
> >     > `/gnu/store/3has7cgd39q9jb9a78vdzjcyycsa6z96-guix-packages-base.drv' failed
> >     > due to signal 9 (Killed)
> >     > build of /gnu/store/3has7cgd39q9jb9a78vdzjcyycsa6z96-guix-packages-base.drv
> >     > failed
> >     > View build log at
> >     > '/var/log/guix/drvs/3h/as7cgd39q9jb9a78vdzjcyycsa6z96-guix-packages-base.drv.bz2'.
> >     > cannot build derivation
> >     > `/gnu/store/z728xwhxnaczkjky15939zjp4v2pvrld-guix-cli.drv': 1 dependencies
> >     > couldn't be built
> >     > building
> >     > /gnu/store/rmbf654gah845f3hbzn9hdamn3xn1s25-guix-config-source.drv...
> >     > cannot build derivation
> >     > `/gnu/store/1i3w8dgf5lzapb8l59i3lriskcd8q30c-guix-packages-base-modules.drv':
> >     > 1 dependencies couldn't be built
> >     > cannot build derivation
> >     > `/gnu/store/4rzrb0xwgh2achzijn6fsdkhgqych6br-guix-packages.drv': 1
> >     > dependencies couldn't be built
> >     > cannot build derivation
> >     > `/gnu/store/4hk3v9q8nlzy18xg6cklmrv1x1hi1f4j-guix-system-tests.drv': 1
> >     > dependencies couldn't be built
> >     > cannot build derivation
> >     > `/gnu/store/ha53vvwh6v1d68v1kj5m43csinxlrflc-guix-system.drv': 1
> >     > dependencies couldn't be built
> >     > cannot build derivation
> >     > `/gnu/store/3q6g7ppayihip0wxhghwkq2nc0qg8kd9-guix-fae72ebb4-modules.drv': 1
> >     > dependencies couldn't be built
> >     > cannot build derivation
> >     > `/gnu/store/gl3gim8cd8p920iw3m5qwdyv6zvlhwnv-guix-fae72ebb4.drv': 1
> >     > dependencies couldn't be built
> >     > cannot build derivation
> >     > `/gnu/store/85vkb01zgkfmy902m352hjcv35d7hzqb-profile.drv': 1 dependencies
> >     > couldn't be built
> >     > guix pull: error: build of
> >     > `/gnu/store/85vkb01zgkfmy902m352hjcv35d7hzqb-profile.drv' failed1
> >     >
> >     >
> >     >
> >     > What can I do? Some help would be much appreciated. Thanks!
> >     >
> >     > Best regards,
> >     > Léon
> >    
> >     The signal 9 (killed) makes me think a C++ program killed. I checked
> >     wikipedia and it says the Banana Pi M3 has 2GB of RAM. Was there
> >     anything else running at the time? 'guix pull' can be resource
> >     intensive, especially on lower powered machines.
> >    
> >     --
> >     Efraim Flashner   <[email-masked]>   אפרים פלשנר
> >     GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
> >     Confidentiality cannot be guaranteed on emails sent or received unencrypted
> 
> -- 
> Bonface M. K. (https://www.bonfacemunyoki.com)
> One Divine Emacs To Rule Them All
> GPG key = D4F09EB110177E03C28E2FE1F5BBAE1E0392253F

-- 
Efraim Flashner   <[email-masked]>   אפרים פלשנר
GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted